/*
 * ADC_Sampler.c
 *
 * Created: 18.07.2021 23:44:58
 *  Author: ZHE
 */ 
#include "ADC_Sampler.h"

volatile uint32_t summa_ADC;
volatile uint16_t count_sampler_ADC;
extern volatile uint8_t flag_stop_adc;
extern volatile uint16_t counter_periods;


void init_ADC(void)
	{
		//  
		#if F_CPU>200000*64
		ADCSRA=(1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0) ;	
		#elif F_CPU>200000*32
		ADCSRA=(1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0) ;
		#elif F_CPU>200000*16
		ADCSRA=(1<<ADPS2) | (0<<ADPS1) | (1<<ADPS0) ;	
		#elif F_CPU>200000*8
		ADCSRA=(0<<ADPS2) | (1<<ADPS1) | (0<<ADPS0) ;
		#elif F_CPU>200000*4
		ADCSRA=(0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0) ;
		#elif F_CPU>200000*2
		ADCSRA=(0<<ADPS2) | (1<<ADPS1) | (0<<ADPS0) ;
		#else 
		ADCSRA=(0<<ADPS2) | (0<<ADPS1) | (1<<ADPS0) ;			
		#endif	
		
		DIDR0=1<<ADC0D;
		
#ifndef AREF
		ADMUX|=1<<REFS0;
#endif		
		
		ADCSRA|=
			(1<<ADEN) |
			(1<<ADIE) |
			0;
	};
//--------------------------------------	
ISR (ADC_vect)
{

	
	if (TCNT1<((F_CPU/FREQ_GEN/PRESC)*DUTY_GEN/1000))
		 {
			 summa_ADC+=ADC;
			 count_sampler_ADC++;
			 
		};
			ADCSRA|=1<<ADSC;
		
		if (!counter_periods)
		{
			ADCSRA&=~(1<<ADEN);
			flag_stop_adc=1;
		};
};	

uint16_t get_AverADC(void)
	{
		return summa_ADC/count_sampler_ADC;		
	};
	
void start_ADC(void)
{
	summa_ADC=0;
	count_sampler_ADC=0;
	ADCSRA|=1<<ADEN;
	ADCSRA|=1<<ADSC;
}	;