#include "Generator.h"

volatile uint16_t counter_periods;

void init_Gen(void)
{
	DDRB|=(1<<PINB2) | (1<<PINB1);// | (1<<PINB0);
	
	//FAST PWM TOP=ICR1
	//OC1A = !OC1B
#if	(F_CPU/FREQ_GEN/PRESC)<500
#warning The value of ICR1<500. 
#endif	
#if	(F_CPU/FREQ_GEN/PRESC)<100
#error The value of ICR1 is too small. You need to change the prescale value.
#endif
#if	(F_CPU/FREQ_GEN/PRESC)>0xFFFF
#error The value of ICR1>65535
#endif

	ICR1=(F_CPU/FREQ_GEN/PRESC);
	
	OCR1A=(F_CPU/FREQ_GEN/PRESC)*DUTY_GEN/1000;
	OCR1B=(F_CPU/FREQ_GEN/PRESC)*DUTY_GEN/1000;

	TIMSK1=1<<TOIE1;
					
};

void start_GEN(void) 
{
	counter_periods=COUNT_PERIOD_GEN;
	
	TCCR1A=
		(1<<COM1A1) | (0<<COM1A0) |
		(1<<COM1B1) | (1<<COM1B0) |
		(1<<WGM11) |	(0<<WGM10) |
		0;
		
	TCCR1B=
		(1<<WGM13) |	(1<<WGM12) |
		PRESC_T1 |
		0;

};

void stop_GEN(void)
{
	//TCCR1B&=~((1<<CS12)|(1<<CS11)|(1<<CS10));
	TCCR1B=0;
	TCCR1A=0;
	TCNT1=0;
	TIFR1=0xFF;	
};
//--------------------------------------------
void init_Repeater(void)
{
	OCR0A=(F_CPU/PRESC0/100);  // 10
	TIMSK0=
		//(1<<TOV0)|
		(1<<OCIE0A)|
		0;		;
	TCCR0A=(1<<WGM01);
	TCCR0B=		
		PRESC_T0 |
		0;	
};
//-----------------------------------
// 1
 ISR (TIMER1_OVF_vect)
 {	 
	counter_periods--;
	if (counter_periods==0)
		{
			stop_GEN();
		};
 };
 
 //-----------------------------------
 
  ISR (TIMER0_COMPA_vect)
  {
	  static uint16_t count_package=PERIOD_PACKAGE_GEN_dMS;
	  count_package--;
	  if (!count_package)
	  {
		start_GEN();  
		count_package=PERIOD_PACKAGE_GEN_dMS; 
		//PINB=1<<PINB0; 
		//PORTB^=1<<PINB0; 
		start_ADC();
	  };	  
  };